/*
@ @licstart  The following is the entire license notice for the
JavaScript code in this file.

Copyright (C) 1997-2017 by Dimitri van Heesch

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

@licend  The above is the entire license notice
for the JavaScript code in this file
*/
var NAVTREE =
[
  [ "Taskflow", "index.html", [
    [ "Quick Start", "index.html", [
      [ "Modern C++ Parallel Task Programming", "index.html#ModernCppParallelTaskProgrammingLibrary", null ],
      [ "Static and Dynamic Tasking", "index.html#StaticDynamicTasking", null ],
      [ "Conditional Tasking", "index.html#ConditionalTasking", null ],
      [ "Composable Tasking", "index.html#ComposableTasking", null ],
      [ "Concurrent CPU-GPU Tasking", "index.html#HeterogeneousTasking", null ],
      [ "How to Install Taskflow?", "index.html#HowToInstallCppTaskflow", null ],
      [ "A Simple First Program", "index.html#ASimpleFirstProgram", null ],
      [ "Compile and Run Your First Program", "index.html#CompileAndRunYourFirstProgram", null ],
      [ "Supported Compilers", "index.html#SupportedCompilers", null ],
      [ "License", "index.html#License", null ]
    ] ],
    [ "Building and Installing", "install.html", [
      [ "Setting Up Taskflow", "install.html#BAISettingUpTaskflow", null ],
      [ "Compile and Link Flags", "install.html#BAICompileAndLinkFlag", null ],
      [ "Supported Compilers", "install.html#BAISupportedCompilers", null ],
      [ "Build Examples, Tests, and Benchmarks", "install.html#BAIBuildExamplesTestsAndBenchmarks", null ]
    ] ],
    [ "Releases", "Releases.html", "Releases" ],
    [ "Cookbook", "Cookbook.html", "Cookbook" ],
    [ "Learning from Examples", "Examples.html", "Examples" ],
    [ "Real Use Cases", "usecases.html", "usecases" ],
    [ "Frequently Asked Questions", "FAQ.html", [
      [ "General Questions", "FAQ.html#GeneralQuestions", [
        [ "Q1: What's the goal of Taskflow?", "FAQ.html#GeneralQuestion1", null ],
        [ "Q2: How do I use Taskflow in my projects?", "FAQ.html#GeneralQuestion2", null ],
        [ "Q3: What is the difference between static tasking and dynamic tasking?", "FAQ.html#GeneralQuestion3", null ],
        [ "Q4: How many tasks can Taskflow handle?", "FAQ.html#GeneralQuestion4", null ],
        [ "Q5: What is the weird hex value, like 0x7fc39d402ab0, in the dumped graph?", "FAQ.html#GeneralQuestion5", null ],
        [ "Q6: Does Taskflow have backward compatibility with C++03/98/11?", "FAQ.html#GeneralQuestion6", null ],
        [ "Q7: How does Taskflow schedule tasks?", "FAQ.html#GeneralQuestion7", null ],
        [ "Q8: What is the overhead of taskflow?", "FAQ.html#GeneralQuestion8", null ],
        [ "Q9: How does it compare to existing task programming systems?", "FAQ.html#GeneralQuestion9", null ],
        [ "Q10: Do you try to simplify the GPU kernel programming?", "FAQ.html#GeneralQuestion10", null ],
        [ "Q11: Do you have any real use cases?", "FAQ.html#GeneralQuestion11", null ]
      ] ],
      [ "Programming Questions", "FAQ.html#ProgrammingQuestions", [
        [ "Q1: What is the difference between Taskflow threads and workers?", "FAQ.html#ProgrammingQuestions1", null ],
        [ "Q2: What is the Lifetime of a Task and a Graph?", "FAQ.html#ProgrammingQuestions2", null ],
        [ "Q3: Is taskflow thread-safe?", "FAQ.html#ProgrammingQuestions3", null ],
        [ "Q4: Is executor thread-safe?", "FAQ.html#ProgrammingQuestions4", null ],
        [ "Q5: My program hangs and never returns after dispatching a taskflow graph. What's wrong?", "FAQ.html#ProgrammingQuestions5", null ],
        [ "Q6: In the following example where B spawns a joined subflow of two tasks B1 and B2, do they run concurrently with task A?", "FAQ.html#ProgrammingQuestions6", null ]
      ] ]
    ] ],
    [ "References", "References.html", [
      [ "Journal", "References.html#RefJournal", null ],
      [ "Conference", "References.html#RefConference", null ]
    ] ],
    [ "Classes", "annotated.html", [
      [ "Class List", "annotated.html", "annotated_dup" ],
      [ "Class Index", "classes.html", null ],
      [ "Class Hierarchy", "hierarchy.html", "hierarchy" ],
      [ "Class Members", "functions.html", [
        [ "All", "functions.html", null ],
        [ "Functions", "functions_func.html", null ]
      ] ]
    ] ],
    [ "Files", "files.html", [
      [ "File List", "files.html", "files_dup" ]
    ] ]
  ] ]
];

var NAVTREEINDEX =
[
".html",
"hierarchy.html"
];

var SYNCONMSG = 'click to disable panel synchronisation';
var SYNCOFFMSG = 'click to enable panel synchronisation';